## librsync 2.0.2

=== CMakeLists.txt ===
# Copyright (C) 2015 Adam Schubert <adam.schubert@sg1-game.net>
# Copyright 2016 Martin Pool
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; either version 2.1 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


project(librsync C)
cmake_minimum_required(VERSION 2.6)

INCLUDE(CMakeDependentOption)
include(GNUInstallDirs)

set(LIBRSYNC_MAJOR_VERSION 2)
set(LIBRSYNC_MINOR_VERSION 0)
set(LIBRSYNC_PATCH_VERSION 2)

set(LIBRSYNC_VERSION
  ${LIBRSYNC_MAJOR_VERSION}.${LIBRSYNC_MINOR_VERSION}.${LIBRSYNC_PATCH_VERSION})

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

if (NOT CMAKE_SYSTEM_PROCESSOR)
	message(FATAL_ERROR "No target CPU architecture set")
endif()

if (NOT CMAKE_SYSTEM_NAME)
	message(FATAL_ERROR "No target OS set")
endif()

set(DO_RS_TRACE 0)
option(ENABLE_TRACE "Compile in detailed trace messages" OFF)
if (ENABLE_TRACE)
    set(DO_RS_TRACE 1)
endif (ENABLE_TRACE)
message(STATUS "DO_RS_TRACE=${DO_RS_TRACE}")

# Add an option to include compression support
option(ENABLE_COMPRESSION "Whether or not to build with compression support" OFF)
# TODO: Remove this warning when compression is implemented.
#       Consider turning compression ON by default.
if (ENABLE_COMPRESSION)
    message(WARNING "Compression support is not functional. See issue #8.")
endif (ENABLE_COMPRESSION)

include ( CheckIncludeFiles )
check_include_files ( alloca.h HAVE_ALLOCA_H )
check_include_files ( dlfcn.h HAVE_DLFCN_H )
check_include_files ( inttypes.h HAVE_INTTYPES_H )
check_include_files ( memory.h HAVE_MEMORY_H )
check_include_files ( stdint.h HAVE_STDINT_H )
check_include_files ( stdlib.h HAVE_STDLIB_H )
check_include_files ( strings.h HAVE_STRINGS_H )
check_include_files ( string.h HAVE_STRING_H )
check_include_files ( sys/stat.h HAVE_SYS_STAT_H )
check_include_files ( sys/types.h HAVE_SYS_TYPES_H )
check_include_files ( unistd.h HAVE_UNISTD_H )
check_include_files ( bzlib.h HAVE_BZLIB_H )
check_include_files ( fcntl.h HAVE_FCNTL_H )
check_include_files ( malloc.h HAVE_MALLOC_H )
check_include_files ( mcheck.h HAVE_MCHECK_H )
check_include_files ( sys/file.h HAVE_SYS_FILE_H )
check_include_files ( zlib.h HAVE_ZLIB_H )

#Temporary configuration
set ( STDC_HEADERS 1 )
set ( HAVE_PROGRAM_INVOCATION_NAME 0)

# Remove compression support if not needed
if (NOT ENABLE_COMPRESSION)
  SET(HAVE_BZLIB_H 0)
  SET(HAVE_ZLIB_H 0)
endif (NOT ENABLE_COMPRESSION)


include ( CheckFunctionExists )
check_function_exists ( alloca HAVE_ALLOCA )
check_function_exists ( fseeko HAVE_FSEEKO )
check_function_exists ( fseeko64 HAVE_FSEEKO64 )
check_function_exists ( _fseeki64 HAVE__FSEEKI64 )
check_function_exists ( fstat64 HAVE_FSTAT64 )
check_function_exists ( _fstati64 HAVE__FSTATI64 )
check_function_exists ( fileno HAVE_FILENO )
check_function_exists ( _fileno HAVE__FILENO )
check_function_exists ( memmove HAVE_MEMMOVE )
check_function_exists ( memset HAVE_MEMSET )
check_function_exists ( strchr HAVE_STRCHR )
check_function_exists ( strerror HAVE_STRERROR )

include(CheckTypeSize)
check_type_size ( "long" SIZEOF_LONG )
check_type_size ( "long long" SIZEOF_LONG_LONG )
check_type_size ( "off_t" SIZEOF_OFF_T )
check_type_size ( "off64_t" SIZEOF_OFF64_T )
check_type_size ( "size_t" SIZEOF_SIZE_T )
check_type_size ( "unsigned int" SIZEOF_UNSIGNED_INT )
check_type_size ( "unsigned long" SIZEOF_UNSIGNED_LONG )
check_type_size ( "unsigned short" SIZEOF_UNSIGNED_SHORT )

# Check for printf "%zu" size_t formatting support.
if(CMAKE_CROSSCOMPILING)
  set(HAVE_PRINTF_Z ON)
  message (STATUS "Cross compiling - assuming printf \"%zu\" size_t formatting support")
else()
  include(CheckCSourceRuns)
  check_c_source_runs("#include <stdio.h>\nint main(){char o[8];sprintf(o, \"%zu\", (size_t)7);return o[0] != '7';}" HAVE_PRINTF_Z)
endif()

include (TestBigEndian)
TEST_BIG_ENDIAN(WORDS_BIGENDIAN)
if (WORDS_BIGENDIAN)
  message(STATUS "System is big-endian.")
else (WORDS_BIGENDIAN)
  message(STATUS "System is little-endian.")
endif (WORDS_BIGENDIAN)

# OS X
if(APPLE)
  set(CMAKE_MACOSX_RPATH ON)
  set(CMAKE_SKIP_BUILD_RPATH FALSE)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}" isSystemDir)
  if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
  endif()
endif()

if (CMAKE_C_COMPILER_ID MATCHES "(Clang|Gnu|GNU)")
  # TODO: Set for MSVC and other compilers.
  # TODO: Set -Werror when the build is clean.

  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
endif()

site_name(BUILD_HOSTNAME)

message (STATUS "PROJECT_NAME  = ${PROJECT_NAME}")
message (STATUS "BUILD_HOSTNAME = ${BUILD_HOSTNAME}")
message (STATUS "CMAKE_SYSTEM = ${CMAKE_SYSTEM}")

# Find POPT
find_package(POPT)
if (POPT_FOUND)
  include_directories(${POPT_INCLUDE_DIRS})
endif (POPT_FOUND)

# Add an option to exclude rdiff executable from build
# This is useful, because it allows to remove POPT dependency if a user is interested only in the
# rsync library itself and not in the rdiff executable
cmake_dependent_option(BUILD_RDIFF "Whether or not to build rdiff executable" ON "POPT_FOUND" OFF)

# Find BZIP
find_package (BZip2)
if (BZIP2_FOUND)
  message (STATUS "Found components for BZIP2")
  message (STATUS "BZIP2_INCLUDE_DIR  = ${BZIP2_INCLUDE_DIR}")
  message (STATUS "BZIP2_LIBRARIES = ${BZIP2_LIBRARIES}")
  include_directories(${BZIP2_INCLUDE_DIR})
endif (BZIP2_FOUND)

# Find ZLIB
find_package (ZLIB)
if (ZLIB_FOUND)
  message (STATUS "Found components for ZLIB")
  message (STATUS "ZLIB_INCLUDE_DIRS  = ${ZLIB_INCLUDE_DIRS}")
  message (STATUS "ZLIB_LIBRARIES = ${ZLIB_LIBRARIES}")
  include_directories(${ZLIB_INCLUDE_DIRS})
endif (ZLIB_FOUND)

# Find libb2
find_package(libb2)
if (LIBB2_FOUND)
  message (STATUS "Found components for libb2")
  message (STATUS "LIBB2_INCLUDE_DIRS  = ${LIBB2_INCLUDE_DIRS}")
  message (STATUS "LIBB2_LIBRARIES = ${LIBB2_LIBRARIES}")
endif (LIBB2_FOUND)

# Add an option to use LIBB2 if found. It defaults to off because the
# reference implementation is currently faster.
cmake_dependent_option(USE_LIBB2 "Use the libb2 blake2 implementation." OFF "LIBB2_FOUND" OFF)

if (USE_LIBB2)
  message (STATUS "Using libb2 blake2 implementation.")
  include_directories(${LIBB2_INCLUDE_DIRS})
  set(blake2_LIBS ${LIBB2_LIBRARIES})
else (USE_LIBB2)
  message (STATUS "Using included blake2 implementation.")
  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/blake2)
  set(blake2_SRCS src/blake2/blake2b-ref.c)
endif (USE_LIBB2)

# Doxygen doc generator.
find_package(Doxygen)
if(DOXYGEN_FOUND)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/doc/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile @ONLY)
    add_custom_target(doc
        ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating API documentation with Doxygen" VERBATIM
    )
endif(DOXYGEN_FOUND)

# Code tidy target to reformat code with indent.
file(GLOB tidy_SRCS src/*.[ch])
set(TYPE_RE "(\\w+_t)")
set(CAST_RE "(\\(${TYPE_RE}( \\*+)?\\))")
add_custom_target(tidy
    COMMENT "Reformatting all code to preferred coding style."
    # Note indent requires all userdefined types to be specified with '-T <type>' args to
    # format them correctly. Rather than do that, we just postprocess with sed.
    #
    # Hide the enclosing 'extern "C" {...}' block for indenting in librsync.h
    COMMAND sed -r -i "s:^(extern \"C\") \\{:\\1;:; s:^\\}(\\s+/\\* extern \"C\" \\*/):;\\1:" src/librsync.h
    # Linux format with no tabs, indent 4, preproc indent 2, 80 columns, swallow blank lines.
    COMMAND indent -linux -nut -i4 -ppi2 -l80 -lc80 -fc1 -sob -T FILE -T Rollsum -T rs_result ${tidy_SRCS}
    # Remove space between * or & and identifier after userdefined types,
    # remove space after type cast for userdefined types like indent -ncs,
    # and remove trailing whitespace.
    COMMAND sed -r -i "s:((${TYPE_RE}|${CAST_RE}) (&|\\*+)) :\\1:g; s:(${CAST_RE}) :\\1:g; s:\\s+$::" ${tidy_SRCS}
    # Restore the enclosing 'extern "C" {...}' block in librsync.h
    COMMAND sed -r -i "s:^(extern \"C\");:\\1 {:; s:^;(\\s+/\\* extern \"C\" \\*/):}\\1:" src/librsync.h
    VERBATIM
)
# Code tidyc target to reformat all code and comments with https://github.com/dbaarda/tidyc.
add_custom_target(tidyc
    COMMENT "Reformatting all code and comments to preferred coding style."
    # Recomended format, reformat linebreaks, reformat comments, 80 columns.
    COMMAND tidyc -R -C -l80 -T FILE -T Rollsum -T rs_result ${tidy_SRCS}
    VERBATIM
)

# Testing

add_executable(isprefix_test
    tests/isprefix_test.c src/isprefix.c)

add_test(NAME isprefix_test COMMAND isprefix_test)

add_executable(rollsum_test
    tests/rollsum_test.c src/rollsum.c)
add_test(NAME rollsum_test COMMAND rollsum_test)

add_executable(hashtable_test
    tests/hashtable_test.c src/hashtable.c)
add_test(NAME hashtable_test COMMAND hashtable_test)

add_executable(sumset_test
    tests/sumset_test.c src/sumset.c src/util.c src/trace.c src/hex.c
    src/checksum.c src/rollsum.c src/mdfour.c src/hashtable.c ${blake2_SRCS})
target_link_libraries(sumset_test ${blake2_LIBS})
add_test(NAME sumset_test COMMAND sumset_test)

# Disable rdiff specific tests
if (BUILD_RDIFF)
    add_test(NAME rdiff_bad_option
             COMMAND rdiff_bad_option.sh ${CMAKE_CURRENT_BINARY_DIR}
             WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests)

    add_test(NAME Help COMMAND help.test ${CMAKE_CURRENT_BINARY_DIR} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests)

    add_test(NAME Mutate COMMAND mutate.test ${CMAKE_CURRENT_BINARY_DIR} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests)
    add_test(NAME Signature COMMAND signature.test ${CMAKE_CURRENT_BINARY_DIR} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests)
    add_test(NAME Sources COMMAND sources.test ${CMAKE_CURRENT_BINARY_DIR} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests)
    add_test(NAME Triple COMMAND triple.test ${CMAKE_CURRENT_BINARY_DIR} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests)
    add_test(NAME Delta COMMAND delta.test ${CMAKE_CURRENT_BINARY_DIR} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests)
    add_test(NAME Changes COMMAND changes.test ${CMAKE_CURRENT_BINARY_DIR} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests)
endif (BUILD_RDIFF)


# `make check` that will build everything and then run the tests.
# See https://cmake.org/Wiki/CMakeEmulateMakeCheck and
# https://github.com/librsync/librsync/issues/49
if (BUILD_RDIFF)
  set(LAST_TARGET rdiff)
else (BUILD_RDIFF)
  set(LAST_TARGET rsync)
endif (BUILD_RDIFF)
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
add_dependencies(check ${LAST_TARGET} isprefix_test rollsum_test hashtable_test sumset_test)


enable_testing()

# Create conf files
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/src/config.h)

# We need to be able to #include "file" from a few places,
# * The original source dir
# * The generated source dir
include_directories(${CMAKE_CURRENT_BINARY_DIR}/src)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)


########### next target ###############

# Only list the .c files that need to be compiled
# (Don't list .h files)

## librsync 0.9.7

=== debian/changelog ===
librsync (0.9.7-9) unstable; urgency=low

  * Switch to debhelper v9.
  * Use dh_autoreconf --as-needed instead of autotools-dev to fix rpath build
    issue with the multiarch path and reduce librsync1 deps.
  * Fix a format-security warning.
  * Fix an implicit-function-declaration warning in the test suite.
  * Set Multi-Arch: same for librsync1.

 -- Andrey Rahmatullin <wrar@wrar.name>  Sun, 05 Feb 2012 14:56:17 +0600

librsync (0.9.7-8) unstable; urgency=low

  * Adopt the package (Closes: #543849).
  * Bump Standards-Version to 3.9.2 (no change needed).
  * Change source format to 3.0 (quilt).
  * Use autotools_dev debhelper addon instead of manual file copying.
  * Enable -Wl,--as-needed.
  * Remove unused compression-related rdiff options (Closes: #608470).
  * Do not build and install the static library.
  * Do not install librsync.la (Closes: #622495)

 -- Andrey Rahmatullin <wrar@wrar.name>  Wed, 13 Apr 2011 12:37:41 +0600

librsync (0.9.7-7) unstable; urgency=low

  * Updating package to standards version 3.8.3.
  * Removing vcs fields.
  * Orphaning package.

 -- Daniel Baumann <daniel@debian.org>  Thu, 27 Aug 2009 07:58:27 +0200

librsync (0.9.7-6) unstable; urgency=low

  * Updating vcs fields in control file.
  * Replacing obsolete dh_clean -k with dh_prep.
  * Updating section of the debug package.
  * Using correct rfc-2822 date formats in changelog.
  * Wrapping build-depends.
  * Updating to standards version 3.8.2.
  * Adding misc depends.
  * Updating section of the source package.
  * Updating year in copyright file.
  * Using quilt rather than dpatch.
  * Minimizing rules file.

 -- Daniel Baumann <daniel@debian.org>  Sun, 02 Aug 2009 18:41:09 +0200

librsync (0.9.7-5) unstable; urgency=medium

  * Adding patch to make rdiff aware of -i and -z (Closes: #435894).

 -- Daniel Baumann <daniel@debian.org>  Tue, 01 Jul 2008 15:33:00 +0200

librsync (0.9.7-4) unstable; urgency=high

  * Adding patch from upstream to fix problem when transfering >4GB from
    a 32bit to 64bit host (Closes: #355178).
  * Updating manpage patch to remove dead link to Linuxcare Australia
    (Closes: #288758).

 -- Daniel Baumann <daniel@debian.org>  Tue, 24 Jun 2008 10:29:00 +0200

librsync (0.9.7-3) unstable; urgency=medium

  * Adding debug package.

 -- Daniel Baumann <daniel@debian.org>  Fri, 20 Jun 2008 13:59:00 +0200

librsync (0.9.7-2) unstable; urgency=low

  * New maintainer (Closes: #487131).
  * Redone debian packaging from scratch.

 -- Daniel Baumann <daniel@debian.org>  Fri, 20 Jun 2008 13:14:00 +0200

librsync (0.9.7-1) unstable; urgency=low

  * New upstream release.
    - Large files are now supported.  (Closes: Bug#277032)
  * Fix description of librsync1.  (Closes: Bug#230839)
  * Describe how to use rdiff.  (Closes: Bug#228005, Bug#156457)
  * Trust upstream's autoconfiscation.

 -- Simon Law <sfllaw@debian.org>  Sun, 28 Nov 2004 18:54:00 -0500

librsync (0.9.6-13) unstable; urgency=high

  * Fix FTBFS with a patch from Steinar H. Gunderston.  (Closes: Bug#262463)

 -- Simon Law <sfllaw@debian.org>  Sat, 28 Aug 2004 11:48:05 -0400

librsync (0.9.6-12) unstable; urgency=low

  * librsync-dev should be in libdevel

 -- Simon Law <sfllaw@debian.org>  Fri, 30 Jul 2004 20:19:20 -0400

librsync (0.9.6-11) unstable; urgency=low

  * New Maintainer.  (Closes: Bug#261580)

 -- Simon Law <sfllaw@debian.org>  Fri, 30 Jul 2004 09:21:47 -0400

librsync (0.9.6-10) unstable; urgency=low

  * Orphaning this package.

 -- John Goerzen <jgoerzen@complete.org>  Mon, 26 Jul 2004 14:58:38 -0500

librsync (0.9.6-9) unstable; urgency=low

  * Made autoconf build-dep versioned.  Closes: #252959.

 -- John Goerzen <jgoerzen@complete.org>  Mon, 26 Jul 2004 09:09:45 -0500

librsync (0.9.6-8) unstable; urgency=low

  * Try using just autoconf now, and drop the other build-deps.
    Was still seeing some errors after -7.

 -- John Goerzen <jgoerzen@complete.org>  Tue, 21 Oct 2003 16:41:41 -0500

librsync (0.9.6-7) unstable; urgency=low

  * Added build-dep on libbz2-dev.
  * Add -a to many debhelper calls.
  * Tightened dh_makeshlibs call in debian/rules.

 -- John Goerzen <jgoerzen@complete.org>  Sat, 11 Oct 2003 22:59:25 -0500

librsync (0.9.6-6) unstable; urgency=low

  * Backed out calls to aclocal, autoconf, automake since they
    somehow caused files to be generated without the .so extension
    sometimes.  Closes: #215289.

 -- John Goerzen <jgoerzen@complete.org>  Sat, 11 Oct 2003 22:47:28 -0500

librsync (0.9.6-5) unstable; urgency=low

  * Fixed clean target so that the Debian diff doesn't have so much junk.
  * Update build-deps on autoconf and automake.

 -- John Goerzen <jgoerzen@complete.org>  Fri, 10 Oct 2003 22:31:53 -0500

librsync (0.9.6-4) unstable; urgency=low

  * Extended description for dev package.  Closes: #210136.
  * configure target runs aclocal, preventing errors.

 -- John Goerzen <jgoerzen@complete.org>  Thu, 09 Oct 2003 16:58:23 -0500

librsync (0.9.6-3) unstable; urgency=low

  * Add CFLAGS=-D_LARGEFILE_SOURCE to configure command line per suggestion
    from upstream to fix tests on hppa.  Closes: #207457.

 -- John Goerzen <jgoerzen@complete.org>  Fri, 29 Aug 2003 08:20:02 -0500

librsync (0.9.6-2) unstable; urgency=low

  * Manually install the rdiff bin because it wasn't anymore.
    Closes: #205469.
  * Fixed description.  Closes: #191658.

 -- John Goerzen <jgoerzen@complete.org>  Mon, 18 Aug 2003 11:25:03 -0500

librsync (0.9.6-1) unstable; urgency=low

  * New upstream release

 -- John Goerzen <jgoerzen@complete.org>  Mon, 11 Aug 2003 17:36:26 -0500

librsync (0.9.5.1-3) unstable; urgency=low

  * Ran autoreconf --force, then rebuilt.  Should make mips even happier
    now.  Closes: #180005.

 -- John Goerzen <jgoerzen@complete.org>  Fri, 07 Feb 2003 14:06:35 -0600

librsync (0.9.5.1-2) unstable; urgency=low

  * Copied /usr/share/misc/config.{guess,sub} over the package defaults.
    This is apparently needed for the mips arch.  Closes: #172497.



=== debian/control ===
Source: librsync
Section: libs
Priority: optional
Maintainer: Andrey Rahmatullin <wrar@wrar.name>
Build-Depends:
 debhelper (>= 9), dh-autoreconf (>= 4~), libbz2-dev, libpopt-dev, zlib1g-dev
Standards-Version: 3.9.2
Homepage: http://librsync.sourceforge.net/
Vcs-Git: git://git.debian.org/collab-maint/librsync.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/librsync.git;a=summary

Package: librsync1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: rsync remote-delta algorithm library
 librsync implements the rsync remote-delta algorithm, which allows for
 efficient remote updates of a file, without requiring the old and new versions
 to both be present at the transmitter. The library uses a stream-based designed
 so that it can be easily embedded into network applications.
 .
 librsync is used by rdiff-backup and duplicity backup applications.

Package: librsync-dev
Section: libdevel
Architecture: any
Depends:
 ${misc:Depends}, librsync1 (= ${binary:Version}), libbz2-dev, libpopt-dev,
 zlib1g-dev
Description: rsync remote-delta algorithm library (development)
 librsync implements the rsync remote-delta algorithm, which allows for
 efficient remote updates of a file, without requiring the old and new versions
 to both be present at the transmitter. The library uses a stream-based designed
 so that it can be easily embedded into network applications.
 .
 This package contains the development files.

Package: librsync-dbg
Section: debug
Priority: extra
Architecture: any
Depends:
 ${misc:Depends}, librsync1 (= ${binary:Version}),
 librsync-dev (= ${binary:Version})
Description: rsync remote-delta algorithm library (debug)
 librsync implements the rsync remote-delta algorithm, which allows for
 efficient remote updates of a file, without requiring the old and new versions
 to both be present at the transmitter. The library uses a stream-based designed
 so that it can be easily embedded into network applications.
 .
 This package contains the debugging symbols.

Package: rdiff
Section: utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Binary diff tool for signature-based differences
 rdiff is a little like diff and patch all rolled into one, with support for
 binary files. Since it takes advantage of the rsync remote-delta algorithm, you
 do not need the source file in the same place as your destination file.
 .
 To use it, you generate a "signature" of the original file and copy the
 signature (which is very small) to the same location as the modified file. Then
 you generate a "delta" which describes the changes required to turn the source
 file into the modified file. The small delta file can then be used to "patch"
 the original file, to transform it into the modified file.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export LDFLAGS=-Wl,--as-needed

%:
	dh ${@} --with autoreconf

override_dh_autoreconf:
	dh_autoreconf --as-needed

override_dh_auto_configure:
	dh_auto_configure -- --enable-shared --disable-static CFLAGS="$(CFLAGS) -D_LARGEFILE_SOURCE"

override_dh_auto_install:
	$(MAKE) prefix=$(CURDIR)/debian/tmp/usr install
	rm -f $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.la
	install -D -m 0755 .libs/rdiff debian/tmp/usr/bin/rdiff

override_dh_install:
	dh_install --fail-missing

override_dh_strip:
	dh_strip --dbg-package=librsync-dbg

## librsync 2.0.2

=== debian/changelog ===
librsync (2.0.2-1ubuntu1) eoan; urgency=medium

  * debian/control, debian/rules:
    - temporarly build without libb to unblock deja-dup, the library is
      optional and in universe at the moment

 -- Sebastien Bacher <seb128@ubuntu.com>  Mon, 23 Sep 2019 22:16:19 +0200

librsync (2.0.2-1) unstable; urgency=medium

  * Upload to unstable.
  * Bump Standards-Version to 4.4.0.
  * Add Build-Depends-Package: to librsync2.symbols.

 -- Andrey Rahmatullin <wrar@debian.org>  Sun, 28 Jul 2019 18:25:56 +0500

librsync (2.0.2-1~exp1) experimental; urgency=medium

  * New upstream version.
  * Upload to experimental.
  * Update the format URL and copyright years in d/copyright.
  * Switch to the debhelper compat level 12.
  * Switch from debian/compat to B-D: debhelper-compat.
  * Bump Standards-Version to 4.3.0.
  * Update Vcs-* fields.

 -- Andrey Rahmatullin <wrar@debian.org>  Sat, 16 Feb 2019 21:08:50 +0500

librsync (2.0.1-1~exp1) experimental; urgency=medium

  * New upstream version.
  * Upload to experimental.
  * Add Build-Depends on cmake.
  * Switch to the debhelper compat level 11.
  * Switch to automatic debug packages.
  * Add 02-GNUInstallDirs.patch to use the CMake GNUInstallDirs module instead
    of hardcoding the install paths.
  * Switch to the libb2 BLAKE2 implementation, add Build-Depends on libb2-dev
    (Closes: #780507).
  * Bump Standards-Version to 4.1.1.
  * Update Vcs-* fields.
  * Update debian/librsync2.symbols (Closes: #857857).
  * Remove zlib1g-dev and libbz2-dev from librsync-dev Depends.
  * Set Rules-Requires-Root: no.

 -- Andrey Rahmatullin <wrar@debian.org>  Mon, 06 Nov 2017 18:47:26 +0500

librsync (1.0.0-1~exp1) experimental; urgency=medium

  * New upstream version.
  * Upload to experimental.
  * Update upstream homepage URLs and the watch file.
  * Install rdiff.magic into rdiff docs.
  * Move librsync.3 to -dev subpackage, add Conflicts: librsync1.
  * Switch from shlibs to symbols.
  * Drop unused B-D on libbz2-dev and zlib1g-dev.

 -- Andrey Rahmatullin <wrar@debian.org>  Mon, 09 Mar 2015 15:39:29 +0500

librsync (0.9.7-10) unstable; urgency=low

  * Fix tests with new automake (Closes: #713443).
  * Do not overwrite LDFLAGS from dpkg-buildflags.
  * Add debian/watch.
  * Make the debug subpackage Multi-Arch: same.
  * Use canonical URLs in Vcs-*.
  * Remove the dependency on -dev from -dbg.
  * Bump Standards-Version to 3.9.4.

 -- Andrey Rahmatullin <wrar@wrar.name>  Thu, 27 Jun 2013 00:38:54 +0600

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,17 @@
 Source: librsync
 Section: libs
 Priority: optional
-Maintainer: Andrey Rahmatullin <wrar@wrar.name>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andrey Rahmatullin <wrar@debian.org>
 Build-Depends:
- debhelper (>= 9), dh-autoreconf (>= 4~), libbz2-dev, libpopt-dev, zlib1g-dev
-Standards-Version: 3.9.2
-Homepage: http://librsync.sourceforge.net/
-Vcs-Git: git://git.debian.org/collab-maint/librsync.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/librsync.git;a=summary
+ debhelper-compat (= 12), cmake, libpopt-dev
+Standards-Version: 4.4.0
+Homepage: https://github.com/librsync/librsync
+Vcs-Git: https://salsa.debian.org/wrar/librsync.git
+Vcs-Browser: https://salsa.debian.org/wrar/librsync
+Rules-Requires-Root: no
 
-Package: librsync1
+Package: librsync2
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -26,8 +28,8 @@
 Section: libdevel
 Architecture: any
 Depends:
- ${misc:Depends}, librsync1 (= ${binary:Version}), libbz2-dev, libpopt-dev,
- zlib1g-dev
+ ${misc:Depends}, librsync2 (= ${binary:Version}), libpopt-dev
+Conflicts: librsync1
 Description: rsync remote-delta algorithm library (development)
  librsync implements the rsync remote-delta algorithm, which allows for
  efficient remote updates of a file, without requiring the old and new versions
@@ -35,21 +37,6 @@
  so that it can be easily embedded into network applications.
  .
  This package contains the development files.
-
-Package: librsync-dbg
-Section: debug
-Priority: extra
-Architecture: any
-Depends:
- ${misc:Depends}, librsync1 (= ${binary:Version}),
- librsync-dev (= ${binary:Version})
-Description: rsync remote-delta algorithm library (debug)
- librsync implements the rsync remote-delta algorithm, which allows for
- efficient remote updates of a file, without requiring the old and new versions
- to both be present at the transmitter. The library uses a stream-based designed
- so that it can be easily embedded into network applications.
- .
- This package contains the debugging symbols.
 
 Package: rdiff
 Section: utils

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_LIBB2=0

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/tmp/usr/share/man/man1
	install -p doc/rdiff.1 debian/tmp/usr/share/man/man1
	mkdir -p debian/tmp/usr/share/man/man3
	install -p doc/librsync.3 debian/tmp/usr/share/man/man3

override_dh_missing:
	dh_missing --fail-missing

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v(\d\S*)\.tar\.gz/librsync-$1\.tar\.gz/ \
  https://github.com/librsync/librsync/tags .*/v(\d\S*)\.tar\.gz

## librsync 2.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,14 +17,14 @@
 
 
 project(librsync C)
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 3.6)
 
 INCLUDE(CMakeDependentOption)
 include(GNUInstallDirs)
 
 set(LIBRSYNC_MAJOR_VERSION 2)
-set(LIBRSYNC_MINOR_VERSION 0)
-set(LIBRSYNC_PATCH_VERSION 2)
+set(LIBRSYNC_MINOR_VERSION 3)
+set(LIBRSYNC_PATCH_VERSION 1)
 
 set(LIBRSYNC_VERSION
   ${LIBRSYNC_MAJOR_VERSION}.${LIBRSYNC_MINOR_VERSION}.${LIBRSYNC_PATCH_VERSION})
@@ -38,6 +38,8 @@
 if (NOT CMAKE_SYSTEM_NAME)
 	message(FATAL_ERROR "No target OS set")
 endif()
+
+option(BUILD_SHARED_LIBS "Build librsync as a shared library." ON)
 
 set(DO_RS_TRACE 0)
 option(ENABLE_TRACE "Compile in detailed trace messages" OFF)
@@ -55,27 +57,14 @@
 endif (ENABLE_COMPRESSION)
 
 include ( CheckIncludeFiles )
-check_include_files ( alloca.h HAVE_ALLOCA_H )
-check_include_files ( dlfcn.h HAVE_DLFCN_H )
-check_include_files ( inttypes.h HAVE_INTTYPES_H )
-check_include_files ( memory.h HAVE_MEMORY_H )
-check_include_files ( stdint.h HAVE_STDINT_H )
-check_include_files ( stdlib.h HAVE_STDLIB_H )
-check_include_files ( strings.h HAVE_STRINGS_H )
-check_include_files ( string.h HAVE_STRING_H )
+check_include_files ( sys/file.h HAVE_SYS_FILE_H )
 check_include_files ( sys/stat.h HAVE_SYS_STAT_H )
 check_include_files ( sys/types.h HAVE_SYS_TYPES_H )
 check_include_files ( unistd.h HAVE_UNISTD_H )
+check_include_files ( fcntl.h HAVE_FCNTL_H )
+check_include_files ( mcheck.h HAVE_MCHECK_H )
+check_include_files ( zlib.h HAVE_ZLIB_H )
 check_include_files ( bzlib.h HAVE_BZLIB_H )
-check_include_files ( fcntl.h HAVE_FCNTL_H )
-check_include_files ( malloc.h HAVE_MALLOC_H )
-check_include_files ( mcheck.h HAVE_MCHECK_H )
-check_include_files ( sys/file.h HAVE_SYS_FILE_H )
-check_include_files ( zlib.h HAVE_ZLIB_H )
-
-#Temporary configuration
-set ( STDC_HEADERS 1 )
-set ( HAVE_PROGRAM_INVOCATION_NAME 0)
 
 # Remove compression support if not needed
 if (NOT ENABLE_COMPRESSION)
@@ -83,9 +72,11 @@
   SET(HAVE_ZLIB_H 0)
 endif (NOT ENABLE_COMPRESSION)
 
+include ( CheckSymbolExists )
+check_symbol_exists ( __func__ "" HAVE___FUNC__ )
+check_symbol_exists ( __FUNCTION__ "" HAVE___FUNCTION__ )
 
 include ( CheckFunctionExists )
-check_function_exists ( alloca HAVE_ALLOCA )
 check_function_exists ( fseeko HAVE_FSEEKO )
 check_function_exists ( fseeko64 HAVE_FSEEKO64 )
 check_function_exists ( _fseeki64 HAVE__FSEEKI64 )
@@ -93,10 +84,6 @@
 check_function_exists ( _fstati64 HAVE__FSTATI64 )
 check_function_exists ( fileno HAVE_FILENO )
 check_function_exists ( _fileno HAVE__FILENO )
-check_function_exists ( memmove HAVE_MEMMOVE )
-check_function_exists ( memset HAVE_MEMSET )
-check_function_exists ( strchr HAVE_STRCHR )
-check_function_exists ( strerror HAVE_STRERROR )
 
 include(CheckTypeSize)
 check_type_size ( "long" SIZEOF_LONG )
@@ -109,7 +96,14 @@
 check_type_size ( "unsigned short" SIZEOF_UNSIGNED_SHORT )
 
 # Check for printf "%zu" size_t formatting support.
-if(CMAKE_CROSSCOMPILING)
+if(WIN32)
+  # CheckCSourceRuns checking for "%zu" succeeds but still gives warnings on win32.
+  set(HAVE_PRINTF_Z OFF)
+  # Not using unsupported %zu generates warnings about using %I64 with MinGW.
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-format")
+  message (STATUS "Compiling to Win32 - printf \"%zu\" size_t formatting support disabled")
+elseif(CMAKE_CROSSCOMPILING)
+  # CheckCSourceRuns doesn't work when cross-compiling; assume C99 compliant support.
   set(HAVE_PRINTF_Z ON)
   message (STATUS "Cross compiling - assuming printf \"%zu\" size_t formatting support")
 else()
@@ -141,8 +135,7 @@
 if (CMAKE_C_COMPILER_ID MATCHES "(Clang|Gnu|GNU)")
   # TODO: Set for MSVC and other compilers.
   # TODO: Set -Werror when the build is clean.
-
-  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -std=c99 -pedantic")
 endif()
 
 site_name(BUILD_HOSTNAME)
@@ -154,6 +147,8 @@
 # Find POPT
 find_package(POPT)
 if (POPT_FOUND)
+  message (STATUS "POPT_INCLUDE_DIRS  = ${POPT_INCLUDE_DIRS}")
+  message (STATUS "POPT_LIBRARIES = ${POPT_LIBRARIES}")
   include_directories(${POPT_INCLUDE_DIRS})
 endif (POPT_FOUND)
 
@@ -165,16 +160,14 @@
 # Find BZIP
 find_package (BZip2)
 if (BZIP2_FOUND)
-  message (STATUS "Found components for BZIP2")
-  message (STATUS "BZIP2_INCLUDE_DIR  = ${BZIP2_INCLUDE_DIR}")
+  message (STATUS "BZIP2_INCLUDE_DIRS  = ${BZIP2_INCLUDE_DIRS}")
   message (STATUS "BZIP2_LIBRARIES = ${BZIP2_LIBRARIES}")
-  include_directories(${BZIP2_INCLUDE_DIR})
+  include_directories(${BZIP2_INCLUDE_DIRS})
 endif (BZIP2_FOUND)
 
 # Find ZLIB
 find_package (ZLIB)
 if (ZLIB_FOUND)
-  message (STATUS "Found components for ZLIB")
   message (STATUS "ZLIB_INCLUDE_DIRS  = ${ZLIB_INCLUDE_DIRS}")
   message (STATUS "ZLIB_LIBRARIES = ${ZLIB_LIBRARIES}")
   include_directories(${ZLIB_INCLUDE_DIRS})
@@ -183,7 +176,6 @@
 # Find libb2
 find_package(libb2)
 if (LIBB2_FOUND)
-  message (STATUS "Found components for libb2")
   message (STATUS "LIBB2_INCLUDE_DIRS  = ${LIBB2_INCLUDE_DIRS}")
   message (STATUS "LIBB2_LIBRARIES = ${LIBB2_LIBRARIES}")
 endif (LIBB2_FOUND)
@@ -214,7 +206,7 @@
 endif(DOXYGEN_FOUND)
 
 # Code tidy target to reformat code with indent.
-file(GLOB tidy_SRCS src/*.[ch])
+file(GLOB tidy_SRCS src/*.[ch] tests/*.[ch])
 set(TYPE_RE "(\\w+_t)")
 set(CAST_RE "(\\(${TYPE_RE}( \\*+)?\\))")
 add_custom_target(tidy
@@ -246,20 +238,37 @@
 
 add_executable(isprefix_test
     tests/isprefix_test.c src/isprefix.c)
-
 add_test(NAME isprefix_test COMMAND isprefix_test)
+
+add_executable(netint_test
+    tests/netint_test.c src/netint.c src/util.c src/trace.c src/tube.c
+    src/scoop.c src/stream.c)
+add_test(NAME netint_test COMMAND netint_test)
 
 add_executable(rollsum_test
     tests/rollsum_test.c src/rollsum.c)
 add_test(NAME rollsum_test COMMAND rollsum_test)
 
+add_executable(rabinkarp_test
+    tests/rabinkarp_test.c src/rabinkarp.c)
+add_test(NAME rabinkarp_test COMMAND rabinkarp_test)
+add_executable(rabinkarp_perf
+    tests/rabinkarp_perf.c src/rabinkarp.c)
+
 add_executable(hashtable_test
     tests/hashtable_test.c src/hashtable.c)
 add_test(NAME hashtable_test COMMAND hashtable_test)
 
+add_executable(checksum_test
+    tests/checksum_test.c src/checksum.c src/rollsum.c src/rabinkarp.c src/mdfour.c ${blake2_SRCS})
+target_compile_options(checksum_test PRIVATE -DLIBRSYNC_STATIC_DEFINE)
+target_link_libraries(checksum_test ${blake2_LIBS})
+add_test(NAME checksum_test COMMAND checksum_test)
+
 add_executable(sumset_test
     tests/sumset_test.c src/sumset.c src/util.c src/trace.c src/hex.c
-    src/checksum.c src/rollsum.c src/mdfour.c src/hashtable.c ${blake2_SRCS})
+    src/checksum.c src/rollsum.c src/rabinkarp.c src/mdfour.c src/hashtable.c ${blake2_SRCS})
+target_compile_options(sumset_test PRIVATE -DLIBRSYNC_STATIC_DEFINE)
 target_link_libraries(sumset_test ${blake2_LIBS})
 add_test(NAME sumset_test COMMAND sumset_test)
 
@@ -286,25 +295,3 @@
 if (BUILD_RDIFF)
   set(LAST_TARGET rdiff)
 else (BUILD_RDIFF)
-  set(LAST_TARGET rsync)
-endif (BUILD_RDIFF)
-add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
-add_dependencies(check ${LAST_TARGET} isprefix_test rollsum_test hashtable_test sumset_test)
-
-
-enable_testing()
-
-# Create conf files
-configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/src/config.h)
-
-# We need to be able to #include "file" from a few places,
-# * The original source dir
-# * The generated source dir
-include_directories(${CMAKE_CURRENT_BINARY_DIR}/src)
-include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)
-
-
-########### next target ###############
-
-# Only list the .c files that need to be compiled
-# (Don't list .h files)

=== debian/changelog ===
librsync (2.3.1-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.5.0, no changes needed.

  [ Andrey Rahmatullin ]
  * New upstream version.
  * Update debian/librsync2.symbols.
  * Switch to the debhelper compat level 13.

 -- Andrey Rahmatullin <wrar@debian.org>  Thu, 06 Aug 2020 00:31:45 +0500

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: librsync
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Andrey Rahmatullin <wrar@debian.org>
+Maintainer: Andrey Rahmatullin <wrar@debian.org>
 Build-Depends:
- debhelper-compat (= 12), cmake, libpopt-dev
-Standards-Version: 4.4.0
+ debhelper-compat (= 13), cmake, libpopt-dev, libb2-dev
+Standards-Version: 4.5.0
 Homepage: https://github.com/librsync/librsync
 Vcs-Git: https://salsa.debian.org/wrar/librsync.git
 Vcs-Browser: https://salsa.debian.org/wrar/librsync

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_LIBB2=1

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/tmp/usr/share/man/man1
	install -p doc/rdiff.1 debian/tmp/usr/share/man/man1
	mkdir -p debian/tmp/usr/share/man/man3
	install -p doc/librsync.3 debian/tmp/usr/share/man/man3

## librsync 2.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,7 +24,7 @@
 
 set(LIBRSYNC_MAJOR_VERSION 2)
 set(LIBRSYNC_MINOR_VERSION 3)
-set(LIBRSYNC_PATCH_VERSION 1)
+set(LIBRSYNC_PATCH_VERSION 2)
 
 set(LIBRSYNC_VERSION
   ${LIBRSYNC_MAJOR_VERSION}.${LIBRSYNC_MINOR_VERSION}.${LIBRSYNC_PATCH_VERSION})
@@ -61,6 +61,7 @@
 check_include_files ( sys/stat.h HAVE_SYS_STAT_H )
 check_include_files ( sys/types.h HAVE_SYS_TYPES_H )
 check_include_files ( unistd.h HAVE_UNISTD_H )
+check_include_files ( io.h HAVE_IO_H )
 check_include_files ( fcntl.h HAVE_FCNTL_H )
 check_include_files ( mcheck.h HAVE_MCHECK_H )
 check_include_files ( zlib.h HAVE_ZLIB_H )
@@ -100,7 +101,7 @@
   # CheckCSourceRuns checking for "%zu" succeeds but still gives warnings on win32.
   set(HAVE_PRINTF_Z OFF)
   # Not using unsupported %zu generates warnings about using %I64 with MinGW.
-  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-format")
+  # set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-format")
   message (STATUS "Compiling to Win32 - printf \"%zu\" size_t formatting support disabled")
 elseif(CMAKE_CROSSCOMPILING)
   # CheckCSourceRuns doesn't work when cross-compiling; assume C99 compliant support.
@@ -133,9 +134,14 @@
 endif()
 
 if (CMAKE_C_COMPILER_ID MATCHES "(Clang|Gnu|GNU)")
-  # TODO: Set for MSVC and other compilers.
   # TODO: Set -Werror when the build is clean.
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -std=c99 -pedantic")
+  if (CMAKE_C_COMPILER_ID MATCHES "Clang")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wconversion")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-sign-conversion")
+  endif()
+elseif(CMAKE_C_COMPILER_ID MATCHES "MSVC")
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /D_CRT_SECURE_NO_WARNINGS")
 endif()
 
 site_name(BUILD_HOSTNAME)
@@ -242,7 +248,8 @@
 
 add_executable(netint_test
     tests/netint_test.c src/netint.c src/util.c src/trace.c src/tube.c
-    src/scoop.c src/stream.c)
+    src/scoop.c)
+target_compile_options(netint_test PRIVATE -DLIBRSYNC_STATIC_DEFINE)
 add_test(NAME netint_test COMMAND netint_test)
 
 add_executable(rollsum_test
@@ -285,13 +292,3 @@
     add_test(NAME Sources COMMAND sources.test ${CMAKE_CURRENT_BINARY_DIR} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests)
     add_test(NAME Triple COMMAND triple.test ${CMAKE_CURRENT_BINARY_DIR} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests)
     add_test(NAME Delta COMMAND delta.test ${CMAKE_CURRENT_BINARY_DIR} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests)
-    add_test(NAME Changes COMMAND changes.test ${CMAKE_CURRENT_BINARY_DIR} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests)
-endif (BUILD_RDIFF)
-
-
-# `make check` that will build everything and then run the tests.
-# See https://cmake.org/Wiki/CMakeEmulateMakeCheck and
-# https://github.com/librsync/librsync/issues/49
-if (BUILD_RDIFF)
-  set(LAST_TARGET rdiff)
-else (BUILD_RDIFF)

=== debian/changelog ===
librsync (2.3.2-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Add M-A: same to librsync-dev.
  * Remove explicit --as-needed.

  [ Andrey Rahmatullin ]
  * New upstream version (Closes: #1003901).
  * Build the static library (Closes: #980333).
  * Bump Standards-Version to 4.6.0.

 -- Andrey Rahmatullin <wrar@debian.org>  Sun, 23 Jan 2022 21:11:47 +0500

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Andrey Rahmatullin <wrar@debian.org>
 Build-Depends:
  debhelper-compat (= 13), cmake, libpopt-dev, libb2-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://github.com/librsync/librsync
 Vcs-Git: https://salsa.debian.org/wrar/librsync.git
 Vcs-Browser: https://salsa.debian.org/wrar/librsync
@@ -29,6 +29,7 @@
 Depends:
  ${misc:Depends}, librsync2 (= ${binary:Version}), libpopt-dev
 Conflicts: librsync1
+Multi-Arch: same
 Description: rsync remote-delta algorithm library (development)
  librsync implements the rsync remote-delta algorithm, which allows for
  efficient remote updates of a file, without requiring the old and new versions

=== debian/rules ===
#!/usr/bin/make -f


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --builddir build-shared -- -DUSE_LIBB2=1
	dh_auto_configure --builddir build-static -- -DUSE_LIBB2=1 -DBUILD_SHARED_LIBS=0

override_dh_auto_build:
	dh_auto_build --builddir build-shared
	dh_auto_build --builddir build-static

override_dh_auto_install:
	dh_auto_install --builddir build-shared
	install -p build-static/librsync.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mkdir -p debian/tmp/usr/share/man/man1
	install -p doc/rdiff.1 debian/tmp/usr/share/man/man1
	mkdir -p debian/tmp/usr/share/man/man3
	install -p doc/librsync.3 debian/tmp/usr/share/man/man3

override_dh_auto_test:
	dh_auto_test --builddir build-shared
	dh_auto_test --builddir build-static

override_dh_auto_clean:
	dh_auto_clean --builddir build-shared
	dh_auto_clean --builddir build-static
